'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useResizeListener = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var useResizeListener = exports.useResizeListener = function useResizeListener(_ref) {
  var threshold = _ref.threshold,
      showLog = _ref.showLog;

  var windowIsNotUndefined = function windowIsNotUndefined() {
    return typeof window !== 'undefined';
  };

  var _useState = (0, _react.useState)({
    isOverThreshold: windowIsNotUndefined() && window.innerWidth >= threshold
  }),
      _useState2 = (0, _slicedToArray3.default)(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var setIsOverThresholdTo = function setIsOverThresholdTo(value) {
    return setState({ isOverThreshold: value });
  };
  var listener = function listener() {
    showLog && console.log(state);
    if (window.innerWidth >= threshold) {
      setIsOverThresholdTo(true);
    } else {
      setIsOverThresholdTo(false);
    }
  };
  (0, _react.useEffect)(function () {
    windowIsNotUndefined() && window.addEventListener('resize', listener);
    return function () {
      windowIsNotUndefined() && window.removeEventListener('resize', listener);
    };
  });

  return state;
};

var ResizeListener = function ResizeListener(_ref2) {
  var children = _ref2.children,
      threshold = _ref2.threshold;
  return children(useResizeListener({ threshold: threshold }));
};

exports.default = ResizeListener;